<template>
  <q-select
    @update:model-value="change_language"
    v-model="model"
    label="Taal"
    for="Taalkiezer"
    name="Taalkiezer"
    :options=languages
    bg-color="white"
    color="black"
    hide-bottom-space
    outlined
    class="lang_selector q-pl-sm"
    tabindex="0"
    dense>
  </q-select>

</template>

<script>
import SharedMethods from "components/SharedMethods";
import {ref} from 'vue'
import {api} from 'boot/axios'


export default {
  name: "LanguageSelector",
  created() {
    this.get_language = SharedMethods.get_lang
    this.set_language = SharedMethods.set_lang
    this.current_langugae = SharedMethods.get_lang()
  },
  props: {
    dts_name: String,
    nt_version: String
  },
  mounted() {
    this.fetchData()
  },
  data() {
    return {
      current_language: String,
      model: ref(SharedMethods.get_lang()),
      languages: ["nl"],
    }
  },
  watch: {
    dts_name: function () {
      this.fetchData()
    }
  },
  methods: {
    change_language: function (value) {
      SharedMethods.set_lang(value)
      console.log("Setting to " + value)
      this.$router.push({path: this.$route.fullPath, query: {lang: SharedMethods.get_lang()}})
    },
    fetchData: function () {
      api.get("/dts/" + this.dts_name + "/languages", {params: {nt_version: this.nt_version}})
        .then(response => {
          this.languages = response.data
          if (! this.languages.includes("nl") && this.current_language() === "nl") {
            console.log("Change language! => " + this.languages[0])
            setTimeout(() => this.change_language(this.languages[0]), 500)
          }
        })
        .catch((error) => {
          this.languages = []
          console.log(error)
        })

    }
  }
}
</script>

<style scoped>
.lang_selector {
  min-width: 100px;
  font-weight: bold;
  border-radius: 5px;
}
</style>
